c925cf1cdea587e0996558fa6b17b0af8f0e9d31
[arvados.git] / build / run-library.sh
1 #!/bin/bash -xe
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 # A library of functions shared by the various scripts in this directory.
7
8 # This is the timestamp about when we merged changed to include licenses
9 # with Arvados packages.  We use it as a heuristic to add revisions for
10 # older packages.
11 LICENSE_PACKAGE_TS=20151208015500
12
13 if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
14     RAILS_PACKAGE_ITERATION=1
15 else
16     RAILS_PACKAGE_ITERATION="$ARVADOS_BUILDING_ITERATION"
17 fi
18
19 debug_echo () {
20     echo "$@" >"$STDOUT_IF_DEBUG"
21 }
22
23 find_python_program() {
24     prog="$1"
25     shift
26     for prog in "$@"; do
27         if "$prog" --version >/dev/null 2>&1; then
28             echo "$prog"
29             return 0
30         fi
31     done
32     cat >&2 <<EOF
33 $helpmessage
34
35 Error: $prog (from Python setuptools module) not found
36
37 EOF
38     exit 1
39 }
40
41 format_last_commit_here() {
42     local format="$1"; shift
43     local dir="${1:-.}"; shift
44     TZ=UTC git log -n1 --first-parent "--format=format:$format" "$dir"
45 }
46
47 version_from_git() {
48     # Output the version being built, or if we're building a
49     # dev/prerelease, output a version number based on the git log for
50     # the given $subdir.
51     local subdir="$1"; shift
52     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
53         echo "$ARVADOS_BUILDING_VERSION"
54         return
55     fi
56
57     local git_ts git_hash
58     declare $(format_last_commit_here "git_ts=%ct git_hash=%h" "$subdir")
59     ARVADOS_BUILDING_VERSION="$($WORKSPACE/build/version-at-commit.sh $git_hash)"
60     echo "$ARVADOS_BUILDING_VERSION"
61 }
62
63 nohash_version_from_git() {
64     local subdir="$1"; shift
65     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
66         echo "$ARVADOS_BUILDING_VERSION"
67         return
68     fi
69     version_from_git $subdir | cut -d. -f1-4
70 }
71
72 timestamp_from_git() {
73     local subdir="$1"; shift
74     format_last_commit_here "%ct" "$subdir"
75 }
76
77 calculate_python_sdk_cwl_package_versions() {
78   python_sdk_ts=$(cd sdk/python && timestamp_from_git)
79   cwl_runner_ts=$(cd sdk/cwl && timestamp_from_git)
80   build_ts=$(cd build && timestamp_from_git version-at-commit.sh)
81
82   ar=($python_sdk_ts $cwl_runner_ts $build_ts)
83   OLDIFS=$IFS
84   IFS=$'\n'
85   max=`echo "${ar[*]}" | sort -nr | head -n1`
86   IFS=$OLDIFS
87
88   python_sdk_version=$(cd sdk/python && nohash_version_from_git)
89   cwl_runner_version=$(cd sdk/cwl && nohash_version_from_git)
90   build_version=$(cd build && nohash_version_from_git version-at-commit.sh)
91
92   if [[ $max -eq $build_ts ]]; then
93     cwl_runner_version=$build_version
94   elif [[ $max -eq $python_sdk_ts ]]; then
95     cwl_runner_version=$python_sdk_version
96   fi
97 }
98
99 handle_python_package () {
100   # This function assumes the current working directory is the python package directory
101   if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
102     # This package doesn't need rebuilding.
103     return
104   fi
105   # Make sure only to use sdist - that's the only format pip can deal with (sigh)
106   python setup.py $DASHQ_UNLESS_DEBUG sdist
107 }
108
109 handle_ruby_gem() {
110     local gem_name="$1"; shift
111     local gem_version="$(nohash_version_from_git)"
112     local gem_src_dir="$(pwd)"
113
114     if [[ -n "$ONLY_BUILD" ]] && [[ "$gem_name" != "$ONLY_BUILD" ]] ; then
115         return 0
116     fi
117
118     if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
119         find -maxdepth 1 -name "${gem_name}-*.gem" -delete
120
121         # -q appears to be broken in gem version 2.2.2
122         $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
123     fi
124 }
125
126 calculate_go_package_version() {
127   # $__returnvar has the nameref attribute set, which means it is a reference
128   # to another variable that is passed in as the first argument to this function.
129   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
130   local -n __returnvar="$1"; shift
131   local oldpwd="$PWD"
132
133   cd "$WORKSPACE"
134   go mod download
135
136   # Update the version number and build a new package if the vendor
137   # bundle has changed, or the command imports anything from the
138   # Arvados SDK and the SDK has changed.
139   declare -a checkdirs=(go.mod go.sum)
140   while [ -n "$1" ]; do
141       checkdirs+=("$1")
142       shift
143   done
144   # Even our rails packages (version calculation happens here!) depend on a go component (arvados-server)
145   # Everything depends on the build directory.
146   checkdirs+=(sdk/go lib build)
147   local timestamp=0
148   for dir in ${checkdirs[@]}; do
149       cd "$WORKSPACE"
150       ts="$(timestamp_from_git "$dir")"
151       if [[ "$ts" -gt "$timestamp" ]]; then
152           version=$(version_from_git "$dir")
153           timestamp="$ts"
154       fi
155   done
156   cd "$oldpwd"
157   __returnvar="$version"
158 }
159
160 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision" [apache-2.0.txt]
161 package_go_binary() {
162     local src_path="$1"; shift
163     local prog="$1"; shift
164     local description="$1"; shift
165     local license_file="${1:-agpl-3.0.txt}"; shift
166
167     if [[ -n "$ONLY_BUILD" ]] && [[ "$prog" != "$ONLY_BUILD" ]]; then
168       # arvados-workbench depends on arvados-server at build time, so even when
169       # only arvados-workbench is being built, we need to build arvados-server too
170       if [[ "$prog" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
171         return 0
172       fi
173     fi
174
175     debug_echo "package_go_binary $src_path as $prog"
176
177     local basename="${src_path##*/}"
178     calculate_go_package_version go_package_version $src_path
179
180     cd $WORKSPACE/packages/$TARGET
181     test_package_presence $prog $go_package_version go
182
183     if [[ "$?" != "0" ]]; then
184       return 1
185     fi
186
187     go get -ldflags "-X git.arvados.org/arvados.git/lib/cmd.version=${go_package_version} -X main.version=${go_package_version}" "git.arvados.org/arvados.git/$src_path"
188
189     local -a switches=()
190     systemd_unit="$WORKSPACE/${src_path}/${prog}.service"
191     if [[ -e "${systemd_unit}" ]]; then
192         switches+=(
193             --after-install "${WORKSPACE}/build/go-python-package-scripts/postinst"
194             --before-remove "${WORKSPACE}/build/go-python-package-scripts/prerm"
195             "${systemd_unit}=/lib/systemd/system/${prog}.service")
196     fi
197     switches+=("$WORKSPACE/${license_file}=/usr/share/doc/$prog/${license_file}")
198
199     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${basename}=/usr/bin/${prog}" "${prog}" dir "${go_package_version}" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=${description}" "${switches[@]}"
200 }
201
202 # Usage: package_go_so lib/foo arvados_foo.so arvados-foo "Arvados foo library"
203 package_go_so() {
204     local src_path="$1"; shift
205     local sofile="$1"; shift
206     local pkg="$1"; shift
207     local description="$1"; shift
208
209     debug_echo "package_go_so $src_path as $pkg"
210
211     calculate_go_package_version go_package_version $src_path
212     cd $WORKSPACE/packages/$TARGET
213     test_package_presence $pkg $go_package_version go || return 1
214     cd $WORKSPACE/$src_path
215     go build -buildmode=c-shared -o ${GOPATH}/bin/${sofile}
216     cd $WORKSPACE/packages/$TARGET
217     local -a fpmargs=(
218         "--url=https://arvados.org"
219         "--license=Apache License, Version 2.0"
220         "--description=${description}"
221         "$WORKSPACE/apache-2.0.txt=/usr/share/doc/$pkg/apache-2.0.txt"
222     )
223     if [[ -e "$WORKSPACE/$src_path/pam-configs-arvados" ]]; then
224         fpmargs+=("$WORKSPACE/$src_path/pam-configs-arvados=/usr/share/doc/$pkg/pam-configs-arvados-go")
225     fi
226     if [[ -e "$WORKSPACE/$src_path/README" ]]; then
227         fpmargs+=("$WORKSPACE/$src_path/README=/usr/share/doc/$pkg/README")
228     fi
229     fpm_build "${WORKSPACE}/${src_path}" "$GOPATH/bin/${sofile}=/usr/lib/${sofile}" "${pkg}" dir "${go_package_version}" "${fpmargs[@]}"
230 }
231
232 default_iteration() {
233     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
234         echo "$ARVADOS_BUILDING_ITERATION"
235         return
236     fi
237     local package_name="$1"; shift
238     local package_version="$1"; shift
239     local package_type="$1"; shift
240     local iteration=1
241     if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
242            [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
243         iteration=2
244     fi
245     echo $iteration
246 }
247
248 _build_rails_package_scripts() {
249     local pkgname="$1"; shift
250     local destdir="$1"; shift
251     local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
252     for scriptname in postinst prerm postrm; do
253         cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
254             >"$destdir/$scriptname" || return $?
255     done
256 }
257
258 rails_package_version() {
259     local pkgname="$1"; shift
260     local srcdir="$1"; shift
261     if [[ -n "$ARVADOS_BUILDING_VERSION" ]]; then
262         echo "$ARVADOS_BUILDING_VERSION"
263         return
264     fi
265     local version="$(version_from_git)"
266     if [ $pkgname = "arvados-api-server" -o $pkgname = "arvados-workbench" ] ; then
267         calculate_go_package_version version cmd/arvados-server "$srcdir"
268     fi
269     echo $version
270 }
271
272 test_rails_package_presence() {
273   local pkgname="$1"; shift
274   local srcdir="$1"; shift
275
276   if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
277     return 1
278   fi
279
280   tmppwd=`pwd`
281
282   cd $srcdir
283
284   local version="$(rails_package_version "$pkgname" "$srcdir")"
285
286   cd $tmppwd
287
288   test_package_presence $pkgname $version rails "$RAILS_PACKAGE_ITERATION"
289 }
290
291 get_complete_package_name() {
292   # if the errexit flag is set, unset it until this function returns
293   # otherwise, the shift calls below will abort the program if optional arguments are not supplied
294   if [ -o errexit ]; then
295     set +e
296     trap 'set -e' RETURN
297   fi
298   # $__returnvar has the nameref attribute set, which means it is a reference
299   # to another variable that is passed in as the first argument to this function.
300   # see https://www.gnu.org/software/bash/manual/html_node/Shell-Parameters.html
301   local -n __returnvar="$1"; shift
302   local pkgname="$1"; shift
303   local version="$1"; shift
304   local pkgtype="$1"; shift
305   local iteration="$1"; shift
306   local arch="$1"; shift
307   if [[ "$iteration" == "" ]]; then
308       iteration="$(default_iteration "$pkgname" "$version" "$pkgtype")"
309   fi
310
311   if [[ "$arch" == "" ]]; then
312     rpm_architecture="x86_64"
313     deb_architecture="amd64"
314
315     if [[ "$pkgtype" =~ ^(src)$ ]]; then
316       rpm_architecture="noarch"
317       deb_architecture="all"
318     fi
319
320     # These python packages have binary components
321     if [[ "$pkgname" =~ (ruamel|ciso|pycrypto|pyyaml) ]]; then
322       rpm_architecture="x86_64"
323       deb_architecture="amd64"
324     fi
325   else
326     rpm_architecture=$arch
327     deb_architecture=$arch
328   fi
329
330   local complete_pkgname="${pkgname}_$version${iteration:+-$iteration}_$deb_architecture.deb"
331   if [[ "$FORMAT" == "rpm" ]]; then
332       # rpm packages get iteration 1 if we don't supply one
333       iteration=${iteration:-1}
334       complete_pkgname="$pkgname-$version-${iteration}.$rpm_architecture.rpm"
335   fi
336   __returnvar=${complete_pkgname}
337 }
338
339 # Test if the package already exists, if not return 0, if it does return 1
340 test_package_presence() {
341     local pkgname="$1"; shift
342     local version="$1"; shift
343     local pkgtype="$1"; shift
344     local iteration="$1"; shift
345     local arch="$1"; shift
346     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
347       # arvados-workbench depends on arvados-server at build time, so even when
348       # only arvados-workbench is being built, we need to build arvados-server too
349       if [[ "$pkgname" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
350         return 1
351       fi
352     fi
353
354     local full_pkgname
355     get_complete_package_name full_pkgname $pkgname $version $pkgtype $iteration $arch
356
357     # See if we can skip building the package, only if it already exists in the
358     # processed/ directory. If so, move it back to the packages directory to make
359     # sure it gets picked up by the test and/or upload steps.
360     # Get the list of packages from the repos
361
362     if [[ "$FORCE_BUILD" == "1" ]]; then
363       echo "Package $full_pkgname build forced with --force-build, building"
364     elif [[ "$FORMAT" == "deb" ]]; then
365       declare -A dd
366       dd[debian10]=buster
367       dd[ubuntu1604]=xenial
368       dd[ubuntu1804]=bionic
369       dd[ubuntu2004]=focal
370       D=${dd[$TARGET]}
371       if [ ${pkgname:0:3} = "lib" ]; then
372         repo_subdir=${pkgname:0:4}
373       else
374         repo_subdir=${pkgname:0:1}
375       fi
376
377       repo_pkg_list=$(curl -s -o - http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/)
378       echo "${repo_pkg_list}" |grep -q ${full_pkgname}
379       if [ $? -eq 0 ] ; then
380         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
381         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" http://apt.arvados.org/pool/${D}-dev/main/${repo_subdir}/${pkgname}/${full_pkgname}
382         return 1
383       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
384         echo "Package $full_pkgname exists, not rebuilding!"
385         return 1
386       else
387         echo "Package $full_pkgname not found, building"
388         return 0
389       fi
390     else
391       centos_repo="http://rpm.arvados.org/CentOS/7/dev/x86_64/"
392
393       repo_pkg_list=$(curl -s -o - ${centos_repo})
394       echo ${repo_pkg_list} |grep -q ${full_pkgname}
395       if [ $? -eq 0 ]; then
396         echo "Package $full_pkgname exists upstream, not rebuilding, downloading instead!"
397         curl -s -o "$WORKSPACE/packages/$TARGET/${full_pkgname}" ${centos_repo}${full_pkgname}
398         return 1
399       elif test -f "$WORKSPACE/packages/$TARGET/processed/${full_pkgname}" ; then
400         echo "Package $full_pkgname exists, not rebuilding!"
401         return 1
402       else
403         echo "Package $full_pkgname not found, building"
404         return 0
405       fi
406     fi
407 }
408
409 handle_rails_package() {
410     local pkgname="$1"; shift
411
412     if [[ -n "$ONLY_BUILD" ]] && [[ "$pkgname" != "$ONLY_BUILD" ]] ; then
413         return 0
414     fi
415     local srcdir="$1"; shift
416     cd "$srcdir"
417     local license_path="$1"; shift
418     local version="$(rails_package_version "$pkgname" "$srcdir")"
419     echo "$version" >package-build.version
420     local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
421     (
422         set -e
423         _build_rails_package_scripts "$pkgname" "$scripts_dir"
424         cd "$srcdir"
425         mkdir -p tmp
426         git rev-parse HEAD >git-commit.version
427         bundle package --all
428     )
429     if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
430         echo "ERROR: $pkgname package prep failed" >&2
431         rm -rf "$scripts_dir"
432         EXITCODE=1
433         return 1
434     fi
435     local railsdir="/var/www/${pkgname%-server}/current"
436     local -a pos_args=("$srcdir/=$railsdir" "$pkgname" dir "$version")
437     local license_arg="$license_path=$railsdir/$(basename "$license_path")"
438     local -a switches=(--after-install "$scripts_dir/postinst"
439                        --before-remove "$scripts_dir/prerm"
440                        --after-remove "$scripts_dir/postrm")
441     if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
442         switches+=(--iteration $RAILS_PACKAGE_ITERATION)
443     fi
444     # For some reason fpm excludes need to not start with /.
445     local exclude_root="${railsdir#/}"
446     local -a exclude_list=(tmp log coverage Capfile\* \
447                            config/deploy\* config/application.yml)
448     # for arvados-workbench, we need to have the (dummy) config/database.yml in the package
449     if  [[ "$pkgname" != "arvados-workbench" ]]; then
450       exclude_list+=('config/database.yml')
451     fi
452     for exclude in ${exclude_list[@]}; do
453         switches+=(-x "$exclude_root/$exclude")
454     done
455     fpm_build "${srcdir}" "${pos_args[@]}" "${switches[@]}" \
456               -x "$exclude_root/vendor/cache-*" \
457               -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
458     rm -rf "$scripts_dir"
459 }
460
461 # Build python packages with a virtualenv built-in
462 fpm_build_virtualenv () {
463   PKG=$1
464   shift
465   PKG_DIR=$1
466   shift
467   PACKAGE_TYPE=${1:-python}
468   shift
469
470   # Set up
471   STDOUT_IF_DEBUG=/dev/null
472   STDERR_IF_DEBUG=/dev/null
473   DASHQ_UNLESS_DEBUG=-q
474   if [[ "$DEBUG" != "0" ]]; then
475       STDOUT_IF_DEBUG=/dev/stdout
476       STDERR_IF_DEBUG=/dev/stderr
477       DASHQ_UNLESS_DEBUG=
478   fi
479   if [[ "$ARVADOS_BUILDING_ITERATION" == "" ]]; then
480     ARVADOS_BUILDING_ITERATION=1
481   fi
482
483   local python=""
484   case "$PACKAGE_TYPE" in
485     python3)
486         python=python3
487         pip=pip3
488         PACKAGE_PREFIX=$PYTHON3_PKG_PREFIX
489         ;;
490   esac
491
492   if [[ "$PKG" != "arvados-docker-cleaner" ]]; then
493     PYTHON_PKG=$PACKAGE_PREFIX-$PKG
494   else
495     # Exception to our package naming convention
496     PYTHON_PKG=$PKG
497   fi
498
499   # arvados-python-client sdist should always be built, to be available
500   # for other dependent packages.
501   if [[ -n "$ONLY_BUILD" ]] && [[ "arvados-python-client" != "$PKG" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
502     return 0
503   fi
504
505   cd $WORKSPACE/$PKG_DIR
506
507   rm -rf dist/*
508
509   # Get the latest setuptools
510   if ! $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
511     echo "Error, unable to upgrade setuptools with"
512     echo "  $pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
513     exit 1
514   fi
515   # filter a useless warning (when building the cwltest package) from the stderr output
516   if ! $python setup.py $DASHQ_UNLESS_DEBUG sdist 2> >(grep -v 'warning: no previously-included files matching'); then
517     echo "Error, unable to run $python setup.py sdist for $PKG"
518     exit 1
519   fi
520
521   PACKAGE_PATH=`(cd dist; ls *tar.gz)`
522
523   if [[ "arvados-python-client" == "$PKG" ]]; then
524     PYSDK_PATH=`pwd`/dist/
525   fi
526
527   if [[ -n "$ONLY_BUILD" ]] && [[ "$PYTHON_PKG" != "$ONLY_BUILD" ]] && [[ "$PKG" != "$ONLY_BUILD" ]]; then
528     return 0
529   fi
530
531   # Determine the package version from the generated sdist archive
532   if [[ -n "$ARVADOS_BUILDING_VERSION" ]] ; then
533       UNFILTERED_PYTHON_VERSION=$ARVADOS_BUILDING_VERSION
534       PYTHON_VERSION=$(echo -n $ARVADOS_BUILDING_VERSION | sed s/~dev/.dev/g | sed s/~rc/rc/g)
535   else
536       PYTHON_VERSION=$(awk '($1 == "Version:"){print $2}' *.egg-info/PKG-INFO)
537       UNFILTERED_PYTHON_VERSION=$(echo -n $PYTHON_VERSION | sed s/\.dev/~dev/g |sed 's/\([0-9]\)rc/\1~rc/g')
538   fi
539
540   # See if we actually need to build this package; does it exist already?
541   # We can't do this earlier than here, because we need PYTHON_VERSION...
542   # This isn't so bad; the sdist call above is pretty quick compared to
543   # the invocation of virtualenv and fpm, below.
544   if ! test_package_presence "$PYTHON_PKG" $UNFILTERED_PYTHON_VERSION $PACKAGE_TYPE $ARVADOS_BUILDING_ITERATION; then
545     return 0
546   fi
547
548   echo "Building $FORMAT package for $PKG from $PKG_DIR"
549
550   # Package the sdist in a virtualenv
551   echo "Creating virtualenv..."
552
553   cd dist
554
555   rm -rf build
556   rm -f $PYTHON_PKG*deb
557   echo "virtualenv version: `virtualenv --version`"
558   virtualenv_command="virtualenv --python `which $python` $DASHQ_UNLESS_DEBUG build/usr/share/$python/dist/$PYTHON_PKG"
559
560   if ! $virtualenv_command; then
561     echo "Error, unable to run"
562     echo "  $virtualenv_command"
563     exit 1
564   fi
565
566   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip; then
567     echo "Error, unable to upgrade pip with"
568     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U pip"
569     exit 1
570   fi
571   echo "pip version:        `build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip --version`"
572
573   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'; then
574     echo "Error, unable to upgrade setuptools with"
575     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U 'setuptools<45'"
576     exit 1
577   fi
578   echo "setuptools version: `build/usr/share/$python/dist/$PYTHON_PKG/bin/$python -c 'import setuptools; print(setuptools.__version__)'`"
579
580   if ! build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel; then
581     echo "Error, unable to upgrade wheel with"
582     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -U wheel"
583     exit 1
584   fi
585   echo "wheel version:      `build/usr/share/$python/dist/$PYTHON_PKG/bin/wheel version`"
586
587   if [[ "$TARGET" != "centos7" ]] || [[ "$PYTHON_PKG" != "python-arvados-fuse" ]]; then
588     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
589   else
590     # centos7 needs these special tweaks to install python-arvados-fuse
591     build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG docutils
592     PYCURL_SSL_LIBRARY=nss build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH
593   fi
594
595   if [[ "$?" != "0" ]]; then
596     echo "Error, unable to run"
597     echo "  build/usr/share/$python/dist/$PYTHON_PKG/bin/$pip install $DASHQ_UNLESS_DEBUG $CACHE_FLAG -f $PYSDK_PATH $PACKAGE_PATH"
598     exit 1
599   fi
600
601   cd build/usr/share/$python/dist/$PYTHON_PKG/
602
603   # Replace the shebang lines in all python scripts, and handle the activate
604   # scripts too. This is a functional replacement of the 237 line
605   # virtualenv_tools.py script that doesn't work in python3 without serious
606   # patching, minus the parts we don't need (modifying pyc files, etc).
607   for binfile in `ls bin/`; do
608     if ! file --mime bin/$binfile |grep -q binary; then
609       # Not a binary file
610       if [[ "$binfile" =~ ^activate(.csh|.fish|)$ ]]; then
611         # these 'activate' scripts need special treatment
612         sed -i "s/VIRTUAL_ENV=\".*\"/VIRTUAL_ENV=\"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
613         sed -i "s/VIRTUAL_ENV \".*\"/VIRTUAL_ENV \"\/usr\/share\/$python\/dist\/$PYTHON_PKG\"/" bin/$binfile
614       else
615         if grep -q -E '^#!.*/bin/python\d?' bin/$binfile; then
616           # Replace shebang line
617           sed -i "1 s/^.*$/#!\/usr\/share\/$python\/dist\/$PYTHON_PKG\/bin\/python/" bin/$binfile
618         fi
619       fi
620     fi
621   done
622
623   cd - >$STDOUT_IF_DEBUG
624
625   find build -iname '*.pyc' -exec rm {} \;
626   find build -iname '*.pyo' -exec rm {} \;
627
628   # Finally, generate the package
629   echo "Creating package..."
630
631   declare -a COMMAND_ARR=("fpm" "-s" "dir" "-t" "$FORMAT")
632
633   if [[ "$MAINTAINER" != "" ]]; then
634     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
635   fi
636
637   if [[ "$VENDOR" != "" ]]; then
638     COMMAND_ARR+=('--vendor' "$VENDOR")
639   fi
640
641   COMMAND_ARR+=('--url' 'https://arvados.org')
642
643   # Get description
644   DESCRIPTION=`grep '\sdescription' $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
645   COMMAND_ARR+=('--description' "$DESCRIPTION")
646
647   # Get license string
648   LICENSE_STRING=`grep license $WORKSPACE/$PKG_DIR/setup.py|cut -f2 -d=|sed -e "s/[',\\"]//g"`
649   COMMAND_ARR+=('--license' "$LICENSE_STRING")
650
651   if [[ "$DEBUG" != "0" ]]; then
652     COMMAND_ARR+=('--verbose' '--log' 'info')
653   fi
654
655   COMMAND_ARR+=('-v' $(echo -n "$PYTHON_VERSION" | sed s/.dev/~dev/g | sed s/rc/~rc/g))
656   COMMAND_ARR+=('--iteration' "$ARVADOS_BUILDING_ITERATION")
657   COMMAND_ARR+=('-n' "$PYTHON_PKG")
658   COMMAND_ARR+=('-C' "build")
659
660   systemd_unit="$WORKSPACE/$PKG_DIR/$PKG.service"
661   if [[ -e "${systemd_unit}" ]]; then
662     COMMAND_ARR+=('--after-install' "${WORKSPACE}/build/go-python-package-scripts/postinst")
663     COMMAND_ARR+=('--before-remove' "${WORKSPACE}/build/go-python-package-scripts/prerm")
664   fi
665
666   COMMAND_ARR+=('--depends' "$PYTHON3_PACKAGE")
667
668   # avoid warning
669   COMMAND_ARR+=('--deb-no-default-config-files')
670
671   # Append --depends X and other arguments specified by fpm-info.sh in
672   # the package source dir. These are added last so they can override
673   # the arguments added by this script.
674   declare -a fpm_args=()
675   declare -a fpm_depends=()
676
677   fpminfo="$WORKSPACE/$PKG_DIR/fpm-info.sh"
678   if [[ -e "$fpminfo" ]]; then
679     echo "Loading fpm overrides from $fpminfo"
680     if ! source "$fpminfo"; then
681       echo "Error, unable to source $WORKSPACE/$PKG_DIR/fpm-info.sh for $PKG"
682       exit 1
683     fi
684   fi
685
686   for i in "${fpm_depends[@]}"; do
687     COMMAND_ARR+=('--depends' "$i")
688   done
689
690   # make sure the systemd service file ends up in the right place
691   # used by arvados-docker-cleaner
692   if [[ -e "${systemd_unit}" ]]; then
693     COMMAND_ARR+=("usr/share/$python/dist/$PKG/share/doc/$PKG/$PKG.service=/lib/systemd/system/$PKG.service")
694   fi
695
696   COMMAND_ARR+=("${fpm_args[@]}")
697
698   # Make sure to install all our package binaries in /usr/bin.
699   # We have to walk $WORKSPACE/$PKG_DIR/bin rather than
700   # $WORKSPACE/build/usr/share/$python/dist/$PYTHON_PKG/bin/ to get the list
701   # because the latter also includes all the python binaries for the virtualenv.
702   # We have to take the copies of our binaries from the latter directory, though,
703   # because those are the ones we rewrote the shebang line of, above.
704   if [[ -e "$WORKSPACE/$PKG_DIR/bin" ]]; then
705     for binary in `ls $WORKSPACE/$PKG_DIR/bin`; do
706       COMMAND_ARR+=("usr/share/$python/dist/$PYTHON_PKG/bin/$binary=/usr/bin/")
707     done
708   fi
709
710   # the python-arvados-cwl-runner package comes with cwltool, expose that version
711   if [[ -e "$WORKSPACE/$PKG_DIR/dist/build/usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool" ]]; then
712     COMMAND_ARR+=("usr/share/python2.7/dist/python-arvados-cwl-runner/bin/cwltool=/usr/bin/")
713   fi
714
715   COMMAND_ARR+=(".")
716
717   debug_echo -e "\n${COMMAND_ARR[@]}\n"
718
719   FPM_RESULTS=$("${COMMAND_ARR[@]}")
720   FPM_EXIT_CODE=$?
721
722   # if something went wrong and debug is off, print out the fpm command that errored
723   if ! fpm_verify $FPM_EXIT_CODE $FPM_RESULTS && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
724     echo "fpm returned an error executing the command:"
725     echo
726     echo -e "\n${COMMAND_ARR[@]}\n"
727   else
728     echo `ls *$FORMAT`
729     mv $WORKSPACE/$PKG_DIR/dist/*$FORMAT $WORKSPACE/packages/$TARGET/
730   fi
731   echo
732 }
733
734 # Build packages for everything
735 fpm_build () {
736   # Source dir where fpm-info.sh (if any) will be found.
737   SRC_DIR=$1
738   shift
739   # The package source.  Depending on the source type, this can be a
740   # path, or the name of the package in an upstream repository (e.g.,
741   # pip).
742   PACKAGE=$1
743   shift
744   # The name of the package to build.
745   PACKAGE_NAME=$1
746   shift
747   # The type of source package.  Passed to fpm -s.  Default "dir".
748   PACKAGE_TYPE=${1:-dir}
749   shift
750   # Optional: the package version number.  Passed to fpm -v.
751   VERSION=$1
752   shift
753
754   if [[ -n "$ONLY_BUILD" ]] && [[ "$PACKAGE_NAME" != "$ONLY_BUILD" ]] && [[ "$PACKAGE" != "$ONLY_BUILD" ]] ; then
755     # arvados-workbench depends on arvados-server at build time, so even when
756     # only arvados-workbench is being built, we need to build arvados-server too
757     if [[ "$PACKAGE_NAME" != "arvados-server" ]] || [[ "$ONLY_BUILD" != "arvados-workbench" ]]; then
758       return 0
759     fi
760   fi
761
762   local default_iteration_value="$(default_iteration "$PACKAGE" "$VERSION" "$PACKAGE_TYPE")"
763
764   declare -a COMMAND_ARR=("fpm" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
765   if [ python = "$PACKAGE_TYPE" ] && [ deb = "$FORMAT" ]; then
766       # Dependencies are built from setup.py.  Since setup.py will never
767       # refer to Debian package iterations, it doesn't make sense to
768       # enforce those in the .deb dependencies.
769       COMMAND_ARR+=(--deb-ignore-iteration-in-dependencies)
770   fi
771
772   if [[ "$DEBUG" != "0" ]]; then
773     COMMAND_ARR+=('--verbose' '--log' 'info')
774   fi
775
776   if [[ -n "$PACKAGE_NAME" ]]; then
777     COMMAND_ARR+=('-n' "$PACKAGE_NAME")
778   fi
779
780   if [[ "$MAINTAINER" != "" ]]; then
781     COMMAND_ARR+=('--maintainer' "$MAINTAINER")
782   fi
783
784   if [[ "$VENDOR" != "" ]]; then
785     COMMAND_ARR+=('--vendor' "$VENDOR")
786   fi
787
788   if [[ "$VERSION" != "" ]]; then
789     COMMAND_ARR+=('-v' "$VERSION")
790   fi
791   if [[ -n "$default_iteration_value" ]]; then
792       # We can always add an --iteration here.  If another one is specified in $@,
793       # that will take precedence, as desired.
794       COMMAND_ARR+=(--iteration "$default_iteration_value")
795   fi
796
797   # Append --depends X and other arguments specified by fpm-info.sh in
798   # the package source dir. These are added last so they can override
799   # the arguments added by this script.
800   declare -a fpm_args=()
801   declare -a build_depends=()
802   declare -a fpm_depends=()
803   declare -a fpm_exclude=()
804   if [[ ! -d "$SRC_DIR" ]]; then
805       echo >&2 "BUG: looking in wrong dir for fpm-info.sh: $pkgdir"
806       exit 1
807   fi
808   fpminfo="${SRC_DIR}/fpm-info.sh"
809   if [[ -e "$fpminfo" ]]; then
810       debug_echo "Loading fpm overrides from $fpminfo"
811       source "$fpminfo"
812   fi
813   for pkg in "${build_depends[@]}"; do
814       if [[ $TARGET =~ debian|ubuntu ]]; then
815           pkg_deb=$(ls "$WORKSPACE/packages/$TARGET/$pkg_"*.deb | sort -rg | awk 'NR==1')
816           if [[ -e $pkg_deb ]]; then
817               echo "Installing build_dep $pkg from $pkg_deb"
818               dpkg -i "$pkg_deb"
819           else
820               echo "Attemping to install build_dep $pkg using apt-get"
821               apt-get install -y "$pkg"
822           fi
823           apt-get -y -f install
824       else
825           pkg_rpm=$(ls "$WORKSPACE/packages/$TARGET/$pkg"-[0-9]*.rpm | sort -rg | awk 'NR==1')
826           if [[ -e $pkg_rpm ]]; then
827               echo "Installing build_dep $pkg from $pkg_rpm"
828               rpm -i "$pkg_rpm"
829           else
830               echo "Attemping to install build_dep $pkg"
831               rpm -i "$pkg"
832           fi
833       fi
834   done
835   for i in "${fpm_depends[@]}"; do
836     COMMAND_ARR+=('--depends' "$i")
837   done
838   for i in "${fpm_exclude[@]}"; do
839     COMMAND_ARR+=('--exclude' "$i")
840   done
841
842   COMMAND_ARR+=("${fpm_args[@]}")
843
844   # Append remaining function arguments directly to fpm's command line.
845   for i; do
846     COMMAND_ARR+=("$i")
847   done
848
849   COMMAND_ARR+=("$PACKAGE")
850
851   debug_echo -e "\n${COMMAND_ARR[@]}\n"
852
853   FPM_RESULTS=$("${COMMAND_ARR[@]}")
854   FPM_EXIT_CODE=$?
855
856   fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
857
858   # if something went wrong and debug is off, print out the fpm command that errored
859   if [[ 0 -ne $? ]] && [[ "$STDOUT_IF_DEBUG" == "/dev/null" ]]; then
860     echo -e "\n${COMMAND_ARR[@]}\n"
861   fi
862 }
863
864 # verify build results
865 fpm_verify () {
866   FPM_EXIT_CODE=$1
867   shift
868   FPM_RESULTS=$@
869
870   FPM_PACKAGE_NAME=''
871   if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
872     FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
873   fi
874
875   if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
876     EXITCODE=1
877     echo
878     echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
879     echo
880     echo $FPM_RESULTS
881     echo
882     return 1
883   elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
884     echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
885     return 0
886   elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
887     EXITCODE=1
888     echo "Error building package for $1:\n $FPM_RESULTS"
889     return 1
890   fi
891 }
892
893 install_package() {
894   PACKAGES=$@
895   if [[ "$FORMAT" == "deb" ]]; then
896     $SUDO apt-get install $PACKAGES --yes
897   elif [[ "$FORMAT" == "rpm" ]]; then
898     $SUDO yum -q -y install $PACKAGES
899   fi
900 }
901
902 title() {
903     printf '%s %s\n' "=======" "$1"
904 }
905
906 checkexit() {
907     if [[ "$1" != "0" ]]; then
908         title "$2 -- FAILED"
909         failures+=("$2 (`timer`)")
910     else
911         successes+=("$2 (`timer`)")
912     fi
913 }
914
915 timer_reset() {
916     t0=$SECONDS
917 }
918
919 timer() {
920     if [[ -n "$t0" ]]; then
921         echo -n "$(($SECONDS - $t0))s"
922     fi
923 }
924
925 report_outcomes() {
926     for x in "${successes[@]}"
927     do
928         echo "Pass: $x"
929     done
930
931     if [[ ${#failures[@]} == 0 ]]
932     then
933         if [[ ${#successes[@]} != 0 ]]; then
934            echo "All test suites passed."
935         fi
936     else
937         echo "Failures (${#failures[@]}):"
938         for x in "${failures[@]}"
939         do
940             echo "Fail: $x"
941         done
942     fi
943 }